#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include <limits.h>
#include "_afintrn.h"

#define DEFL_WH 16

int scale;
int offx, offy;
int sw,sh;
int selspline, selpoint;
int startcurvespline;
int mouse_vis = FALSE;

int *cur_curve = 0;
int nr_splines_in_cur_curve;
int max_nr_splines_in_cur_curve = 0;
int drawback = TRUE;


typedef struct WORK_SHP
{
   SPLINE_SHAPE *shape;
   int max_splines;

   int *nextspline; //points for each spline to the spline it is connected to at the end
   
} WORK_SHP;

WORK_SHP **shapes;
int num_letters = 0;
int base = -1;
int cur_letter = -1;
int font_height;
int curspline = 0;

int yellow;
int lblue;
int black;
int lgray;
int dgray;
int white,black;
int red;
int blue;
int green;

int newx[4],newy[4], numnew = 0;
int incurve = FALSE;

BITMAP *sbuf;
BITMAP *crosshair;

RGB_MAP rgbmap;

char *help_strings[] =
{
   "h - help",
   "N - new font",
   "c - start/ end curve",
   "e - edit different letter",
   "S - save",
   "L - load",
   "Q - quit",
   "m - move letter",
   "n - scale letter",
   "w/W -change width",
   "D - del curve",
   "b - toggle background",
   "mouse -  select/move points, add new points",
   "shift mouse - move entire curve",
   "  ",
   "press ESC to exit help"
};
#define HLP_SIZE 16

void drawscreen();

void init()
{
   int i;
   const int sz = sizeof(help_strings)/ sizeof(char *);
   ASSERT(HLP_SIZE == sz);
 
   allegro_init();
   set_color_depth(16);
   if (set_gfx_mode(GFX_SAFE, 640,480,0,0))
   {
         allegro_message("cannot set videomode");
         exit(1);
   }

   sbuf = create_bitmap_ex(16, SCREEN_W, SCREEN_H);

   crosshair = create_bitmap(15, 15);
   

   if (!sbuf || !crosshair)
      exit(1); //!


   generate_332_palette(desktop_palette);


   for (i=0;i<64;i++)
   {
      desktop_palette[i].r =
      desktop_palette[i].g =
      desktop_palette[i].b = i;
   }
   if (bitmap_color_depth(screen) == 8)
   {
      set_palette(desktop_palette);
      rgb_map = &rgbmap;
      create_rgb_table(rgb_map, desktop_palette, NULL);
   }


   yellow = makecol16(255,255,0);
   black = makecol16(0,0,0);
   lblue = makecol16(200,200,255);
   lgray = makecol16(150,150,150);
   dgray = makecol16(100,100,100);
   white = makecol16(255,255,255);
   black = makecol16(0,0,0);
   red = makecol16(255,0,0);
   blue = makecol16(0,0,255);
   green =makecol16(0,255,0);
   
   install_keyboard();
   install_mouse();

   clear_to_color(crosshair, bitmap_mask_color(crosshair));
   LOCK_VARIABLE(crosshair);
   hline(crosshair, 0, 6, 16, white);
   hline(crosshair, 0, 7, 16, red);
   hline(crosshair, 0, 8, 16, white);
   vline(crosshair, 6, 0, 16, white);
   vline(crosshair, 7, 0, 16, red);
   vline(crosshair, 8, 0, 16, white);
   rectfill(crosshair, 4, 4, 10, 10, bitmap_mask_color(crosshair));

   show_mouse(screen);
   mouse_vis = TRUE;
   gui_fg_color = black;
   gui_bg_color = white;
   gui_mg_color = lgray;


}

static void grey_out_screen()
{
   int i, j;
   for (j=0;j<SCREEN_H;j++)
   {
      for (i=0;i<SCREEN_W;i+=2)
      {
         putpixel(screen, i+(j%2),j, dgray);
      }
   }

}


static void my_popup_dialog(DIALOG *d, int init)
{
   grey_out_screen();
   do_dialog(d, init);
   drawscreen();
}

void help()
{
   const int sz = sizeof(help_strings)/ sizeof(char *);
   DIALOG hlp_dlg[HLP_SIZE + 2];
   int i;


   hlp_dlg[sz + 1].proc = NULL;
   hlp_dlg[sz + 1].dp = NULL;

   hlp_dlg[0].proc = d_box_proc;
   hlp_dlg[0].x = 0;
   hlp_dlg[0].y = 0;
   hlp_dlg[0].w = 580;
   hlp_dlg[0].h = 460;
   hlp_dlg[0].flags = 0;
   hlp_dlg[0].key = 0;
   hlp_dlg[0].d1 = 0;
   hlp_dlg[0].d2 = 0;

   for (i=0;i<sz;i++)
   {
      hlp_dlg[i+1].proc = d_ctext_proc;
      hlp_dlg[i+1].x = 290;
      hlp_dlg[i+1].y = 5 + 10 * i;
      hlp_dlg[i+1].w = 280;
      hlp_dlg[i+1].h = 10;
      hlp_dlg[i+1].dp = help_strings[i];
      hlp_dlg[i+1].dp2 = NULL;
      hlp_dlg[i+1].dp3 = NULL;
      hlp_dlg[i+1].flags = 0;
      hlp_dlg[i+1].key = 0;
      hlp_dlg[i+1].d1 = 0;
      hlp_dlg[i+1].d2 = 0;
   }


   set_dialog_color(hlp_dlg,black, white);
   centre_dialog(hlp_dlg);
   my_popup_dialog(hlp_dlg,-1);

   while(key[KEY_ESC]);
   clear_keybuf();

}

#define DLG_TEXT_INDEX 1
#define DLG_EDIT_INDEX 2
DIALOG getstring_dlg[] =
{
   /* (dialog proc) (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)(d1) (d2)  (dp)  (dp2) (dp3) */
   { d_box_proc,     0,    0,   500, 100,   255,  0,    0,    0,       0,   0,  NULL, NULL, NULL  },
   { d_text_proc,   10,   12,   480,  20,   255,  0,    0,    0,       0,   0,  NULL, NULL, NULL  },
   { d_edit_proc,   10,   32,   480,  20,   255,  0,    0,    0,       0,   0,  NULL, NULL, NULL  },
   { d_button_proc, 80,   70,  161,   20,   255,  0,   13,    D_EXIT,  0,   0,  "OK", NULL, NULL  },
   { NULL,           0,    0,    0,    0,    0,    0,    0,    0,      0,   0,  NULL, NULL, NULL  }
};

void getstring(char const *message, char *buffer, int max)
{


   getstring_dlg[DLG_EDIT_INDEX].d1 = max;
   getstring_dlg[DLG_EDIT_INDEX].d2 = strlen(buffer);
   getstring_dlg[DLG_EDIT_INDEX].dp = buffer;
   getstring_dlg[DLG_TEXT_INDEX].dp = strdup(message);
   
   if (!getstring_dlg[DLG_TEXT_INDEX].dp)
       return; //! out of mem


   centre_dialog(getstring_dlg);
   set_dialog_color(getstring_dlg,black, white);

   my_popup_dialog(getstring_dlg, DLG_EDIT_INDEX);

   free(getstring_dlg[DLG_TEXT_INDEX].dp);


}

int getint(char const *message, int def, int min, int max) // def =-1 = no def
{
   char buffer[20] = {0,0,0,0};
   int ret = min - 1;

   if (def !=-1)
      sprintf(buffer,"%d",def);

   while(ret < min || ret > max)
   {
      getstring(message, buffer, 20);
      ret = strtol(buffer, NULL,0);
   }
   return ret;
}

void newfont()
{
   base = getint("Enter unicode index of the first character in the font",65, 0, INT_MAX);

   font_height = getint("Enter height in pixels at scale 1", DEFL_WH,1, INT_MAX);
   shapes = NULL;
   num_letters = 0;
   cur_letter = -1;
}

void calc_scale_etc()
{
   SPLINE_SHAPE *s;
   int xscale, yscale;
   
   s = shapes[cur_letter]->shape;
   sw = s->w  +8;
   sh = s->h  +8;

   selspline = selpoint = 0;

   xscale = SCREEN_W / sw;
   yscale = (SCREEN_H - 12) / sh;

   scale = MIN(xscale, yscale);

   offx = 4 * scale;
   offy = 4 * scale;

}

int xshape2scr(int x)
{
   return x * scale / 100 + offx;
}

int xscr2shape(int x)
{
   return (x - offx) * 100 / scale;
}

int yshape2scr(int y)
{
   return y * scale / 100 + offy;
}

int yscr2shape(int y)
{
   return (y - offy) * 100 / scale;
}


void find_cur_curve()
{

   int s = selspline;


   
   nr_splines_in_cur_curve = 0;
   if (incurve || cur_letter<0 ||!shapes[cur_letter]->shape || !shapes[cur_letter]->shape->nr_splines)
   {
      return;
   }
   
   if (shapes[cur_letter]->shape->nr_splines > max_nr_splines_in_cur_curve)
   {
      max_nr_splines_in_cur_curve = shapes[cur_letter]->shape->nr_splines + 10;

      cur_curve = realloc(cur_curve, max_nr_splines_in_cur_curve * sizeof(int));

      if (!cur_curve)
         exit(1); //!
   }

   do
   {
      cur_curve[nr_splines_in_cur_curve] = s;
      nr_splines_in_cur_curve++;
      s = shapes[cur_letter]->nextspline[s];

   } while (s !=selspline);

   
}

void move_shape(int dx, int dy)
{
   dx = dx * 100 /scale;
   dy = dy * 100 /scale;


   shape_translate(shapes[cur_letter]->shape, dx, dy);

}

void scale_shape(int dx, int dy)
{
   double sx = pow(1.01, dx);
   double sy = pow(1.01, dy);

   shape_scale(shapes[cur_letter]->shape, sx, sy);
   
}


void edit_letter(int code)
{
   int index = code - base;
   char buffer[100];
   int i;
   
   if (base == -1)
   {
      alert("cannot edit characters", "without font.", NULL
             ,"Ok", NULL,13,0);
      return;
   }

   if (index < 0)
   {
      alert("cannot edit characters", "before the base character", "of the font"
             ,"Ok", NULL,13,0);
   }

   if (index+1 > num_letters)
   {
      sprintf(buffer,"to %d characters.", index + 1);
      if (1 != alert("This will enlarge the font", buffer, "Is that ok.", "Yes", "no",13,27))
         return;

      shapes = realloc(shapes, (index + 1) * sizeof(WORK_SHP *));

      if (!shapes)
         exit(1); //! better check

      for (i = num_letters; i<index+1;i++)
          shapes[i] = NULL;

      num_letters = index+1;
   }

   if (!shapes[index])
   {
      shapes[index] = malloc(sizeof (WORK_SHP));

      if (!shapes[index])
         exit(1); //!

      shapes[index]->shape = malloc(sizeof(SPLINE_SHAPE) + 8 * 10 * sizeof(int));
      shapes[index]->nextspline = malloc(sizeof(int) * 10);

      if (!shapes[index]->shape || !shapes[index]->nextspline)
         exit(1); //!

      shapes[index]->max_splines = 10;
      shapes[index]->shape->nr_splines = 0;
      shapes[index]->shape->h = font_height;
      shapes[index]->shape->w = getint("enter character width (pixels) at scale 1", font_height, 1, 4 * font_height);
      
   }
   
   cur_letter = index;

   incurve = 0;
   numnew = 0;
   calc_scale_etc();
   

}

void drawstatusbar()
{
   text_mode(yellow);
   rectfill(sbuf, 0, SCREEN_H - 11, SCREEN_W,SCREEN_H, yellow);
   textprintf(sbuf, font, 10, SCREEN_H - 10, black,
              "num_char %d base %d font_height %d cur %d '%c' Unicode %d",
              num_letters, base, font_height, cur_letter, cur_letter < 128 ? cur_letter + base: ' ', cur_letter+base);
                    
   textprintf_right(sbuf, font, SCREEN_W - 10, SCREEN_H - 10, black, "h=help Q=quit");
   text_mode(-1);
}



void drawpoint(SPLINE_SHAPE *s, int spline, int point, int color)
{
   int x, y;

   
   ASSERT(s);
   ASSERT(spline < s->nr_splines);
   ASSERT(point < 4);


   x = xshape2scr(s->data[spline][2*point]);
   y = yshape2scr(s->data[spline][2*point + 1]);

   circlefill(sbuf, x, y, 3, color);
}

int findlastspline(WORK_SHP  *ws, int spl)
{
   int i;
   for (i=0;i<ws->shape->nr_splines;i++)
   {
      if (ws->nextspline[i] == spl)
         return i;
   }

   ASSERT(FALSE);

   return 0;
}

void drawshape()
{
   int i;
   SPLINE_SHAPE *s = shapes[cur_letter]->shape;
   static BITMAP *scratch32 = NULL;
   static BITMAP *scratch16 = NULL;

   if (!scratch32 || sw > scratch32->w || sh > scratch32->h)
   {
      if (scratch32)
          destroy_bitmap(scratch32);
          
      scratch32 = create_bitmap_ex(32,sw, sh);
      
      if (scratch16)
          destroy_bitmap(scratch16);
          
      scratch16 = create_bitmap_ex(16,sw, sh);
   }

   if (!scratch32 || !scratch16)
      exit(1);

   set_clip(sbuf, 0,0, SCREEN_W-1, SCREEN_H - 12);

   rectfill(sbuf, 0, 0, 2*offx+s->w*scale, 2*offy+s->h*scale, lgray);
   rectfill(sbuf, offx, offy, offx+s->w*scale, offy+s->h*scale, white);

   if (!incurve && drawback)
   {
      solid_mode();
      clear_to_color(scratch32, makecol32(0,255,0));
      clear_to_color(scratch16, lgray);
      rectfill(scratch16, 4, 4, sw - 5, sh - 5, white);
      
      drawing_mode(DRAW_MODE_TRANS, NULL,0,0);
      set_write_alpha_blender();
      draw_shape(scratch32, 4, 4, -1, 1, 1, s);
      set_alpha_blender();
      draw_trans_sprite(scratch16, scratch32,0,0);
      solid_mode();
      stretch_blit(scratch16, sbuf, 0,0,sw,sh, 0,0,sw*scale,sh*scale);
   }


   for (i=0;i<=sw;i++)
   {
      vline(sbuf,i * scale, 0, sh * scale, lblue);
   }

   for (i=0;i<=sh;i++)
   {
      hline(sbuf,0,i * scale, sw*scale, lblue);
   }

   

   draw_shape_outline(sbuf, offx, offy, black, scale, scale, s);


   for (i=0;i<numnew;i++)
   {
     if (i == 0 || i == 3)
        circlefill(sbuf, xshape2scr(newx[i]), yshape2scr(newy[i]), 3, red);
     else
        circlefill(sbuf, xshape2scr(newx[i]), yshape2scr(newy[i]), 3, blue);
   }

   if (!incurve && shapes[cur_letter]->shape->nr_splines && selspline >=0)
   {
       if (!mouse_b)
       {
            for (i=0;i<4;i++)
                drawpoint(shapes[cur_letter]->shape, selspline, i, dgray);
                
            if (selpoint == 0 || selpoint == 3)
               drawpoint(shapes[cur_letter]->shape, selspline, selpoint, red);
            else
               drawpoint(shapes[cur_letter]->shape, selspline, selpoint, blue);
       }
       else
       {
            switch(selpoint)
            {
             case 0:
               drawpoint(shapes[cur_letter]->shape, selspline, 1, blue);
               drawpoint(shapes[cur_letter]->shape, findlastspline(shapes[cur_letter], selspline), 2, blue);
               break;
             case 3:
               drawpoint(shapes[cur_letter]->shape, selspline, 2, blue);
               drawpoint(shapes[cur_letter]->shape, shapes[cur_letter]->nextspline[selspline], 1, blue);
               break;
             case 2:
              /* fallthrough*/
             case 1:
               line(sbuf,
                    xshape2scr(shapes[cur_letter]->shape->data[selspline][0]),
                    yshape2scr(shapes[cur_letter]->shape->data[selspline][1]),
                    xshape2scr(shapes[cur_letter]->shape->data[selspline][2]),
                    yshape2scr(shapes[cur_letter]->shape->data[selspline][3]), red);
               line(sbuf,
                    xshape2scr(shapes[cur_letter]->shape->data[selspline][4]),
                    yshape2scr(shapes[cur_letter]->shape->data[selspline][5]),
                    xshape2scr(shapes[cur_letter]->shape->data[selspline][6]),
                    yshape2scr(shapes[cur_letter]->shape->data[selspline][7]), red);
               break;
            }
            draw_shape_outline(sbuf, offx, offy, black, scale, scale, s);
       }
   }

   if (key_shifts & KB_SHIFT_FLAG)
   {
      find_cur_curve();
      for (i=0;i<nr_splines_in_cur_curve;i++)
      {
           drawpoint(shapes[cur_letter]->shape, cur_curve[i], 0, red);
           drawpoint(shapes[cur_letter]->shape, cur_curve[i], 3, red);
      }
      
   }


   set_clip(sbuf, 0,0, SCREEN_W-1, SCREEN_H - 1);
}

void drawscreen()
{
   clear_to_color(sbuf, white);

   if (num_letters && cur_letter >=0 && shapes[cur_letter])
   {
      drawshape();
   }

   drawstatusbar();
   scare_mouse();
   blit(sbuf, screen, 0,0,0,0,SCREEN_W, SCREEN_H);
   unscare_mouse();
}

void addspline()
{
   int i;
   WORK_SHP *ws = shapes[cur_letter];

   if (ws->shape->nr_splines >=ws->max_splines)
   {
      ws->max_splines +=10;

      ws->shape = realloc(ws->shape, sizeof(SPLINE_SHAPE) + sizeof(int) * 8 * ws->max_splines);
      ws->nextspline = realloc(ws->nextspline, sizeof(int) * ws->max_splines);
      if (!ws->shape || ! ws->nextspline)
      {
         exit(1);//! malloc check
      }
   }

   for (i=0;i<4;i++)
   {

      ws->shape->data[ws->shape->nr_splines][2*i] = newx[i];
      ws->shape->data[ws->shape->nr_splines][2*i+1] = newy[i];
   }
   
   ws->nextspline[ws->shape->nr_splines] = ws->shape->nr_splines+1;
   ws->shape->nr_splines++;
}

// x/y in screencoords
void addpoint(int x, int y)
{

   newx[numnew] = xscr2shape(x);
   newy[numnew] = yscr2shape(y);

   numnew++;

   if (numnew > 3)
   {
      addspline();
      numnew = 0;

      newx[0] = newx[3];
      newy[0] = newy[3];
      numnew=1;
   }

   
}



void move_curve(int dx, int dy)
{
   int i,j;

   dx = dx * 100 /scale;
   dy = dy * 100 /scale;

   if (!shapes[cur_letter]->shape->nr_splines)
      return;

   find_cur_curve();

   for (i=0;i<nr_splines_in_cur_curve;i++)
   {
      for (j=0;j<4;j++)
      {
         shapes[cur_letter]->shape->data[cur_curve[i]][2*j] += dx;
         shapes[cur_letter]->shape->data[cur_curve[i]][2*j+1] += dy;
      }
   }
}

int findpoint(int mx, int my,int *spline, int *point)
{
   SPLINE_SHAPE *s = shapes[cur_letter]->shape;
   int i,j;
   int distance = SCREEN_W * SCREEN_W + SCREEN_H * SCREEN_H;
   int x,y;
   int fs = 0, fp = 0;
   int changed = FALSE;

   for (i=0;i<s->nr_splines;i++)
   {
      for (j=0;j<4;j++)
      {
          x = xshape2scr(s->data[i][2*j]);
          y = yshape2scr(s->data[i][2*j+1]);

          if ((mx - x)*(mx - x) + (my - y) * (my - y) < distance)
          {
             distance = (mx - x)*(mx - x) + (my - y) * (my - y);
             fs = i;
             fp = j;
          }
          
      }
   }

   if (fs != *spline || fp != *point)
       changed = TRUE;


   *spline = fs;
   *point = fp;

   return changed;
}

void del_curve()
{
   int min,max,i;
   
   if (!shapes[cur_letter]->shape->nr_splines)
      return;

   find_cur_curve();

   min = max = cur_curve[0];

   for (i=0;i<nr_splines_in_cur_curve;i++)
   {
      min = MIN(min, cur_curve[i]);
      max = MAX(max, cur_curve[i]);
   }

   for (i=min;i+max+1 - min<shapes[cur_letter]->shape->nr_splines;i++)
   {
      shapes[cur_letter]->nextspline[i] = shapes[cur_letter]->nextspline[i+max - min + 1];
   }
   shape_delete_splines(shapes[cur_letter]->shape, min, max);



   findpoint(mouse_x, mouse_y, &selspline, &selpoint);
}


void movepoint(int mx, int my)
{
   SPLINE_SHAPE *s = shapes[cur_letter]->shape;
   WORK_SHP *w = shapes[cur_letter];
   int x = xscr2shape(mx);
   int y = yscr2shape(my);
   int l;

   if (!s->nr_splines)
       return;

   s->data[selspline][2* selpoint] = x;
   s->data[selspline][2* selpoint+1] = y;

   if (selpoint == 3)
   {
      s->data[w->nextspline[selspline]][0] = x;
      s->data[w->nextspline[selspline]][1] = y;
   }
   else if (!selpoint)
   {
      l = findlastspline(w, selspline);
      s->data[l][6] = x;
      s->data[l][7] = y;
      
   }
   
}



void save(char *name)
{
   /*
text font format:
----start---------
AlDynFont  must start line
base       -font base
numchar    - number of chars
-------for each char
numspline
w
h
-------for each spline
x1 y1 x2 y2 x3 y3 x4 y4   control pts

 */

   PACKFILE *out;
   char buffer[1024];
   int i,j;
   
   out = pack_fopen(name, "wp");

   if (!out)
   {
      return; //! alert
   }

   sprintf(buffer, "AlDynFont\n");
   pack_fputs(buffer, out);

   sprintf(buffer, "%d\n", base);
   pack_fputs(buffer, out);
   
   sprintf(buffer, "%d\n", num_letters);
   pack_fputs(buffer, out);

   for (i=0;i<num_letters;i++)
   {
      if (shapes[i])
      {
         sprintf(buffer, "%d\n", shapes[i]->shape->nr_splines);
         pack_fputs(buffer, out);
         sprintf(buffer, "%d\n", shapes[i]->shape->w);
         pack_fputs(buffer, out);
         sprintf(buffer, "%d\n", shapes[i]->shape->h);
         pack_fputs(buffer, out);
         for (j=0;j<shapes[i]->shape->nr_splines;j++)
         {
            sprintf(buffer, "%d %d %d %d %d %d %d %d\n",
                            shapes[i]->shape->data[j][0],
                            shapes[i]->shape->data[j][1],
                            shapes[i]->shape->data[j][2],
                            shapes[i]->shape->data[j][3],
                            shapes[i]->shape->data[j][4],
                            shapes[i]->shape->data[j][5],
                            shapes[i]->shape->data[j][6],
                            shapes[i]->shape->data[j][7]);
            pack_fputs(buffer, out);

         }
      }
      else
      {
         pack_fputs("0\n", out);
         pack_fputs("0\n", out);
         pack_fputs("0\n", out);
      }
   }

   pack_fclose(out);
}

void  findloops(WORK_SHP *ws)
{
   SPLINE_SHAPE *s = ws->shape;
   int i,j;

   int haslast[1024];

   if (s->nr_splines > 1024)
   {
      exit(1); //!moet beter
   }
   
   for (i=0; i<s->nr_splines;i++)
   {
      haslast[i] = -1;
   }
   for (i=0; i<s->nr_splines;i++)
   {
      ws->nextspline[i] = i + 1;
      if (i == s->nr_splines - 1
          || s->data[i][6] != s->data[i+1][0]
          || s->data[i][7] != s->data[i+1][1])
      {
         for (j=i;j>=0;j--)
         {
            if (haslast[j]< 0)
            {
               ws->nextspline[i] = j;
               haslast[j] = i;

               ASSERT(s->data[i][6] == s->data[j][0]);
               ASSERT(s->data[i][7] == s->data[j][1]);
               break;
            }
         }
      }
      else
      {
         haslast[i+1] = i;
      }
   }
}


void load(char *name)
{
   /*
text font format:
----start---------
AlDynFont  must start line
base       -font base
numchar    - number of chars
-------for each char
numspline
w
h
-------for each spline
x1 y1 x2 y2 x3 y3 x4 y4   control pts

 */

   int i;
   int first_nonempty = -1;
   FONT *tmp;
   SPLINE_FONT_DATA *s;

   tmp = splif_load_font(name);

   if (!tmp)
   {
      //! alert
      return;
   }

   s = (SPLINE_FONT_DATA *)tmp->data;

   base = s->start;
   num_letters = s->end - s->start + 1;


   for (i=0;i<num_letters;i++)
   {
      if (s->glyphs[i])
      {
         first_nonempty = i;
         break;
      }
   }


   if (first_nonempty < 0)
   {
//      alert font empty
        base = -1;
        num_letters = 0;
        return;
   }

   cur_letter = first_nonempty;


   shapes = malloc(sizeof(WORK_SHP *) * num_letters);
   if (!shapes)
      exit(1); //! malloc check




   for (i=0;i<num_letters;i++)
   {
      
      if (s->glyphs[i])
      {
         shapes[i] = malloc(sizeof (WORK_SHP));

         if (!shapes[i])
            exit(1); //!malloc check
            
         shapes[i]->shape = s->glyphs[i];
         shapes[i]->max_splines = shapes[i]->shape->nr_splines;
         shapes[i]->nextspline = malloc(sizeof(int) * shapes[i]->max_splines);

         if (!shapes[i]->nextspline)
            exit(1); //! malloc check

         findloops(shapes[i]);
      }
      else
          shapes[i] = NULL;
   }

   edit_letter(cur_letter + base);
   font_height = shapes[first_nonempty]->shape->h;

   free(s->glyphs);

   free(s);

   free(tmp);
}


int main(int argc, char **argv)
{
   int k,a,s;
   int refresh = TRUE;
   int cur;
   int lx,ly;
   char buffer[1024];
   int mouse_dx, mouse_dy;
   int last_shift = 0;
   
   init();

   while(1)
   {


      if (num_letters >0 && shapes[cur_letter])
      {
         if (key_shifts != last_shift)
            refresh = TRUE;

         last_shift = key_shifts;
         
         if (mouse_b || key[KEY_SPACE])
         {
         
            if (incurve)
            {
               addpoint(mouse_x, mouse_y);
               show_mouse(NULL);
               mouse_vis = 0;
               drawscreen();
               while (mouse_b || key[KEY_SPACE]);
            }
            else
            {


               if (key_shifts & KB_SHIFT_FLAG)
               {
                  get_mouse_mickeys(&mouse_dx, &mouse_dy);
                  mouse_dx = mouse_dy = 0;
                  show_mouse(NULL);
                  while(mouse_b)
                  {
                     move_curve(mouse_dx, mouse_dy);
                     get_mouse_mickeys(&mouse_dx, &mouse_dy);
                     drawscreen();
                  }
                  show_mouse(screen);

               }
               else
               {
                  while(mouse_b)
                  {
                     movepoint(mouse_x, mouse_y);
                     show_mouse(NULL);
                     drawscreen();
                     show_mouse(screen);
                  }
               }
            }

            show_mouse(NULL);
            mouse_vis = 0;
            drawscreen();
         }

         if (!incurve)
         {
            if (findpoint(mouse_x, mouse_y, &selspline, &selpoint))
               refresh = TRUE;

            if (key[KEY_M])
            {
               lx = mouse_x;
               ly = mouse_y;
               while(key[KEY_M])
               {
                  move_shape(mouse_x - lx, mouse_y - ly);
                  lx = mouse_x;
                  ly = mouse_y;
                  show_mouse(NULL);
                  drawscreen();
                  show_mouse(screen);
               }
               clear_keybuf();
            }

            if (key[KEY_N])
            {
               lx = mouse_x;
               ly = mouse_y;
               while(key[KEY_N])
               {
                  scale_shape(mouse_x - lx, mouse_y - ly);
                  lx = mouse_x;
                  ly = mouse_y;
                  show_mouse(NULL);
                  drawscreen();
                  show_mouse(screen);
               }
               clear_keybuf();
            }
            
         }

         if (!mouse_b && !mouse_vis)
         {
            show_mouse(screen);
            mouse_vis = TRUE;
         }
         
      }

      
      if (keypressed())
      {
         k = readkey();
         a = k & 0xFF;
         s = k >> 8;

         if (s == KEY_ESC)
            exit(0);

         refresh = TRUE;
         switch(a)
         {
          case 'Q':
           exit(0);
           break;
          case 'b':
           drawback = !drawback;
           break;
          case 'S':
           buffer[0] = 0;
           if (file_select("Save file", buffer, NULL))
               save(buffer);
           break;
          case 'L':
           buffer[0] = 0;
           if (file_select("Load file", buffer, NULL))
              load(buffer);
           break;
           
          case 'h':
          case 'H':
           help();
           break;
          case 'N':
           newfont();
           break;
          case 'D':
           del_curve();
           break;
          case 'e':
           edit_letter(getint("Enter Unicode index of letter to edit.", cur_letter+1+base,base,INT_MAX));
           break;
          case 'w':
           shapes[cur_letter]->shape->w--;
           if (shapes[cur_letter]->shape->w<1)
               shapes[cur_letter]->shape->w = 1;

           calc_scale_etc();
           break;
          case 'W':
           shapes[cur_letter]->shape->w++;
           sw = shapes[cur_letter]->shape->w  +8;

           calc_scale_etc();
           break;

          case 'c':
           incurve = !incurve;
           if (!incurve)
           {
              numnew = 0;
              set_mouse_sprite(NULL);
              set_mouse_sprite_focus(0, 0);
              cur = shapes[cur_letter]->shape->nr_splines - 1;
              
              if ( cur >= startcurvespline) // close curve
              {
                  shapes[cur_letter]->shape->data[cur][6] =
                    shapes[cur_letter]->shape->data[startcurvespline][0];
                    
                  shapes[cur_letter]->shape->data[cur][7] =
                    shapes[cur_letter]->shape->data[startcurvespline][1];

                  shapes[cur_letter]->nextspline[cur] = startcurvespline;
              }
           }
           else
           {
              set_mouse_sprite(crosshair);
              set_mouse_sprite_focus(8, 8);
              startcurvespline = shapes[cur_letter]->shape->nr_splines;
           }
           break;
          default:
           break;
         }
      }

      if (refresh)
      {
        drawscreen();
        refresh = FALSE;
      }
   }
   
   return 0;
}
END_OF_MAIN();
